# Given a file containing students names and their years (freshman, sophomore,
# junior, or senior) for this class, creates a report (in a file) that
# says the year and how many students from that year are in this class, on the
# same line.
#
# Note: this is not the most efficient solution because we are going through a 
# file multiple times, instead of checking for all the search times in the line
# at the same time.  There is sometimes a tradeoff between ease of writing
# (e.g., using a function) and efficiency.  Usually, the programmer's time is
# more valuable than computational time, but there are limits.
#
# CSCI 111

def main():
    FILENAME = "data/years2.dat"
    
    OUTFILE = "summary.txt"
    
    sumFile = file(OUTFILE, "w")
    
    numFY = getNumOccurences( FILENAME, "FY")
    sumFile.write("FY \t" + str(numFY) + "\n" )

    numSophomores = getNumOccurences( FILENAME, "SO")
    sumFile.write("SO \t" + str(numSophomores) + "\n" )
    
    numJuniors = getNumOccurences( FILENAME, "JR")
    sumFile.write("JR \t" + str(numJuniors) + "\n" )
    
    numSeniors = getNumOccurences( FILENAME, "SR")
    sumFile.write("SR \t" + str(numSeniors) + "\n" )
    
    sumFile.close()

# Given the name of a file (a string) and a search term (a string),
# returns the number of times that searchTerm occurs in the file
def getNumOccurences( filename, searchTerm):

    # creates a new file object, opening the file in "read" mode
    dataFile = file(filename, "r")

    numOccurences = 0

    # reads in the file line-by-line and prints the content of the file
    for line in dataFile:
        if not line.startswith("#") : 
            if searchTerm in line:
                numOccurences += 1

    # close the file with the method "close"
    dataFile.close()

    #print "We found", searchTerm, numOccurences, "times in the file"
    return numOccurences
    
main()
