# Given a file of the form
# <lastname> <year>
# Create a mapping between the last names and years
# CSCI 111

# Create an empty dictionary
lastnameToYear = {}

FILENAME = "data/years.dat"

# open file in read mode
yearsFile = file(FILENAME, "r")

# read through the file line by line
for line in yearsFile:
    # A line of the file looks like <Lastname> <Year>
    # So, split the line on spaces
    dataList = line.split()
    
    # The first item in the data list is the last name
    lastname = dataList[0] 
    # The second item in the data list is the year
    year = dataList[1]
    
    # add mapping from lastname --> year to the dictionary
    lastnameToYear[lastname] = year

yearsFile.close()

# display dictionary in a pretty way
lastnamesList = lastnameToYear.keys()
lastnamesList.sort()

for lastname in lastnamesList:
    print lastname, "-->", 
    print lastnameToYear[lastname]


