# Given a file of the form
# <lastname> <year>
# Create a mapping between the last names and years
# CSCI 111

def main():
    
    # create an empty dictionary
    yearToNumStudents = {}
    
    FILENAME = "data/years.dat"
    
    # open file in read mode
    yearsFile = file(FILENAME, "r")
    
    # read through the file, line by line
    for line in yearsFile:
        # A line of the file looks like <Lastname> <Year>
        # So, split the line on spaces
        dataList = line.split()
        
        # The first item in the data list is the last name
        lastname = dataList[0] 
        # The second item in the data list is the year
        year = dataList[1]
     
        # update the dictionary
        updateDictionary(yearToNumStudents, year)
        
    yearsFile.close()
    
    displaySortedDictionary(yearToNumStudents)

# Display the dictionary, with the keys in sorted order
# Input: the dictionary to display
def displaySortedDictionary( dictionary ):
    keys = dictionary.keys()
    keys.sort()

    for key in keys:
        print key, "-->", 
        print dictionary[key]

# Update the dictionary
# Precondition: dictionary that maps keys to a count;
# a key that may or may not already be in the dictionary
def updateDictionary( dictionary, key ):
    # add to the dictionary (count is 1)
    if key not in dictionary : 
        dictionary[key] = 1
    else: 
        value = dictionary[key] + 1
        dictionary[key] = value
    
    """
    # Alternative solution, but not in a generic form
        numStudents = yearToNumStudents.get(year)
        
        if numStudents is None:
            yearToNumStudents[year] = 1
        else:
            numStudents = yearToNumStudents[year] + 1
            yearToNumStudents[year] = numStudents
    """        
main()
