# Determine the number of students in each major
# Assumes the file contains
# <LASTNAME> [<MAJORS>]
# by CS111

MAJORSFILE = "data/majors.all.dat"

from dictionary_helpers import *

# open the majors file
majorsFile = file(MAJORSFILE, "r")

# create the dictionary that maps majors --> number of majors
majorsToNumStudents = {}

for line in majorsFile:
    # a line of the file contains a student's last name and then their list of majors  
    
    # split the line into "words"
    dataList = line.split()

    # the first word is the student's last name
    lastName = dataList[0]
    
    # check if the student has a major
    if len(dataList) > 1:
        # the rest of dataList is a list of majors
        majorsList = dataList[1:]
        
        # update the dictionary for every major
        for major in majorsList:
            updateDictionary(majorsToNumStudents, major)
    else:
        # student doesn't have a major
        updateDictionary(majorsToNumStudents)

majorsFile.close()

displaySortedDictionary( majorsToNumStudents)
