from card import *
from random import shuffle

class Deck:
    """ A class to represent a deck of playing cards."""
    
    def __init__(self):
        # the instance variable that represents the cards
        self.cards = []
        
        # executes 4 times (once for each suit)
        for suit in ["clubs","hearts","diamonds","spades"]:
            # executes 13 times (once for each rank)
            for rank in range(2,15):
                # the body of this loop gets executed a total of 52
                # times
                self.cards.append(Card(rank, suit))

    def __str__(self):
        "Returns a string representation of the cards in the deck"
        
        # accumulate the cards in the deck in a string
        result = ""
        for c in self.cards:
            # Either of the following two lines do the same thing,
            # have the same result:
        
            #result += c.__str__() + "\n"
            result += str(c) + "\n"
        return result

    # TODO: Complete remaining functionality
    
    def shuffle(self):
        "Shuffle the cards that are currently in the deck"
        shuffle(self.cards)  # from random module

    def numCardsRemaining(self):
        return len(self.cards)
        
    def draw(self):
        cardDrawn = self.cards.pop(0)
        return cardDrawn
        
    def deal(self, numCards):
        hand =[]
        for x in xrange( numCards ):
            card = self.draw()
            hand.append(card)
        return hand
        
        
def main():
    d = Deck()
    print "*"*8, "Before shuffling:", "*"*8
    print d
    
    d.shuffle()
    print "*"*8, "After shuffling:", "*"*8
    print d
    
    print "Number of cards remaining", d.numCardsRemaining()
    
    print "Draw the top card:", d.draw()
    
    print "Number of cards remaining", d.numCardsRemaining()

    hand = d.deal(5)

    print "My hand contains:"    
    for card in hand:
        print card
    
    
# Since I am probably going to import this script into another script,
# I only want to call main() when it's *not* imported
if __name__ == "__main__":
    main()
