# Given a file containing students names and their years (freshman, sophomore,
# junior, or senior) for this class, creates a report (in a file) that
# says the year and how many students from that year are in this class, on the
# same line.
#
# Note: this is not the most efficient solution because we are going through a 
# file multiple times, instead of checking for all the search times in the line
# at the same time.  There is sometimes a tradeoff between ease of writing
# (e.g., using a function) and efficiency.  Usually, the programmer's time is
# more valuable than computational time, but there are limits.
#
# CSCI 111

FILENAME="data/years2.dat"
REPORTNAME="data/report.dat"

def main():
    term = "FY"

    reportFile = file(REPORTNAME, "w")
    
    reportFile.write("# This file contains ...\n")

    fycount = getNumLinesTermOccurs(FILENAME, term)
    reportFile.write("%-10s %5d\n" % (term, fycount))
    
    term = "SO"
    yearcount = getNumLinesTermOccurs(FILENAME, term)
    reportFile.write("%-10s %5d\n" % (term, yearcount))
    
    term = "JR"
    yearcount = getNumLinesTermOccurs(FILENAME, term)
    reportFile.write("%-10s %5d\n" % (term, yearcount))
    
    term = "SR"
    yearcount = getNumLinesTermOccurs(FILENAME, term)
    reportFile.write("%-10s %5d\n" % (term, yearcount))

    reportFile.close()

# given the name of the file (string) and the term to search for (string)
# returns the number of lines that the term occurs on.
def getNumLinesTermOccurs(filename, term):
    count = 0
    lineNum = 1
    searchFile = file(filename, "r")
    
    # check every line in the file and see where term occurs
    for line in searchFile:
        line = line.strip()
        if line[0] != "#":
            if term in line:
                count += 1
                #print lineNum, line    
        lineNum += 1
    searchFile.close()
    return count

main()
