from card import *
from random import shuffle

class Deck:
    """ A class to represent a deck of playing cards."""
    
    def __init__(self):
        "Constructs a new Deck object, with all the standard cards in it."
        # the instance variable that represents the cards
        self.deck = []
        
        # executes 4 times (once for each suit)
        for suit in ["clubs","hearts","diamonds","spades"]:
            # executes 13 times (once for each rank)
            for rank in range(2,15):
                # the body of this loop gets executed a total of 52
                # times
                card = Card(rank, suit)
                self.deck.append(card)

    def __str__(self):
        "Returns a string representation of the cards in the deck"
        
        # accumulate the cards in the deck in a string
        result = ""
        for c in self.deck:
            # Either of the following two lines do the same thing,
            # have the same result:
        
            #result += c.__str__() + "\n"
            result += str(c) + "\n"
        return result

    # TODO: Complete remaining functionality
    
    def shuffle(self):
        "Shuffle the cards that are currently in the deck"
        shuffle(self.deck)  # from random module

    def numCardsRemaining(self):
        return len(self.deck)
        
    def draw(self):
        cardDrawn = self.deck.pop(0)
        return cardDrawn
        
    def deal(self, numCards):
        cardsDealt =[]
        for x in xrange( numCards ):
            card = self.draw()
            cardsDealt.append(card)
        return cardsDealt
        
def main():
    d = Deck()
    print d
    
    # TODO: Test the new methods
    
    
# Since I am probably going to import this script into another script,
# I only want to call main() when it's *not* imported
if __name__ == "__main__":
    main()
