# Script to print the students' code neatly
# by Sara Sprenkle, 09.2007
#

ARGS=1       # Number of arguments expected.
E_BADARGS=65  # Exit value if incorrect number of args passed.

test $# -lt $ARGS && echo "Usage: `basename $0` <labdirname>" && exit $E_BADARGS

LABDIR=$1

if [ -f $LABDIR ];
then
  echo "ERROR: entered argument must be a directory"
  exit  
fi

base=`basename $LABDIR`

#ls $LABDIR/

if [ -e $base.out ]; 
then
    rm $base.out
fi


for FILE in `ls $LABDIR/`
do
    if [ -f $LABDIR/$FILE ];
    then
	echo "Printing $FILE"
	echo -----------------------$FILE-------------------- >> $base.out
	cat $LABDIR/$FILE >> $base.out
    fi
done

if [ -e $base.out ];
then 
    echo "CREATING FILE: $base.ps"
    enscript -2r -Epython --word-wrap --mark-wrapped-lines=box $base.out -o $base.ps
else
    echo "ERROR: $base.out does not exist; could not create ps file"
fi